<template>
	<div class="codex azure-gradient lightestazure-color">
		<div class="header double-col-padding row-padding flex space">
			<div class="title hustle medium">codex</div>
			
			<div class="collection-score columns-12" v-tooltip="'collection_score_tooltip'">
				<div class="flex space col-padding text">
					<div class="bold uppercase">{{ getLocale('collection_score') }}</div>
					<div class="bold uppercase">{{ collection_score }}</div>
				</div>
				
				<div class="score-bar">
					<div class="bar">
						<div class="dot lightestazure-border lightestazure-bkg" :style="{left : (collection_score/2)+'%'}"></div>
						<div class="base lightestazure-bkg" :style="{width : (collection_score/2)+'%'}"></div>
					</div>
				</div>
			</div>
			
			<div class="actions align-right">
				<close-icon color="#B3EDFF" @clicked="$emit('close')"/>
			</div>
		</div>
		
		<div class="container double-col-padding double-row-padding">
			<svg width="100%" height="100%" xmlns="http://www.w3.org/2000/svg">
				<defs>
					<pattern id="smallGrid" width="1.785714285%" height="0.8849557%" patternUnits="userSpaceOnUse">
						<path d="M 32 0 L 0 0 0 32" fill="none" stroke="gray" stroke-dasharray="1,2" stroke-width="2"/>
					</pattern>
				</defs>

			  <rect width="100%" height="100%" fill="url(#smallGrid)" />
			</svg>

			<div class="grid">
				<div 
					v-for="(vairus, index) in flat_vairus_list" 
					class="entry" 
					:class="[
						vairus.rarity, 
						vairus.biome,
						index%5 == 4 ? 'margin-right' : '',
						parts[index] == 'glitch' ? 'glitch' : ''
					]"
				>
					<div class="card-header flex space" v-on:click="details = vairus">
						<div class="name hustle medium center">{{vairus.name}}</div>
					</div>

					<div class="content" v-on:click="details = vairus">
						<div class="wrapper">
							<div class="image" :class="[vairus.biome+'-border']">
								<div class="part visible" :style="imageStyle(vairus.id, 'base', (vairus.unlocked && ( (parts[index] == '' || parts[index] == undefined)|| vairus.affinities[parts[index]]  )))"></div>
								<div class="part" v-for="(value, attribute) in vairus.affinities" :class="{ visible : parts[index] == attribute }" :style="imageStyle(vairus.id, attribute, parts[index] == attribute && vairus.affinities[parts[index]])"></div>
							</div>
						</div>
					</div>
					
					
					<div class="card-footer flex">
						<div 
							v-for="(status, attribute) in vairus.affinities" 
							class="attribute" 
							:class="[attribute+'-bkg', parts[index] == attribute ? 'selected' : '', status ? '' : 'locked']"
							v-on:click="selectPart(index, attribute)"
							v-tooltip="attribute"
						></div>
					</div>
				</div>
			</div>
		</div>
		
		<transition name="fade">
			<div class="details" v-if="details">
				<div class="backdrop" v-on:click="details = null"></div>
				
				<div class="content row-padding col-padding azure-gradient lightestazure-color">
					<div class="title align-center">
						<span class="hustle">{{details.label}}</span>
						
						<close-icon color="#B3EDFF" @clicked="details = null"/>
					</div>
					
					<div class="header flex space row-padding">
						
						<div class="catched small-font">
							<div class="uppercase">{{getLocale('owned')}}</div>
							<div>{{ details.catched }}</div>
						</div>
						
						<div class="category small-font">
							<div class="uppercase">{{getLocale('biome')}}</div>
							<div>{{getLocale(details.biome)}}</div>
						</div>
						
						<div class="rarity small-font">
							<div class="uppercase">{{getLocale('rarity')}}</div>
							<div>{{getLocale(details.rarity)}}</div>
						</div>
					</div>
					
					<div class="midsection flex h-center">
						<svg width="100%" height="100%" xmlns="http://www.w3.org/2000/svg">
							<defs>
								<pattern id="smallGrid2" width="20px" height="20px" patternUnits="userSpaceOnUse">
									<path d="M 32 0 L 0 0 0 32" fill="none" stroke="gray" stroke-dasharray="1,2" stroke-width="2"/>
								</pattern>
							</defs>

							<rect width="100%" height="100%" fill="url(#smallGrid2)" />
						</svg>
						
						<div class="image-wrapper" >
							<div class="image" :class="[details.biome+'-border']">
								<div class="part visible" :style="imageStyle(details.id, 'base', (details.unlocked && ( (details_parts == '' || details_parts == undefined)|| details.affinities[details_parts]  )))"></div>
								<div class="part" v-for="(value, attribute) in details.affinities" :class="{ visible : details_parts == attribute }" :style="imageStyle(details.id, attribute, details_parts == attribute && details.affinities[details_parts])"></div>
							</div>
						</div>
					</div>
						
					<div class="description">
						<span v-if="details.unlocked">{{ getLocale('vairus_description_'+details.id)}}</span>
					</div>
				</div>
			</div>
		</transition>
	</div>
</template>


<script>
	import Vue from 'vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';


	export default {
		props: ['list'],
		data: function () {
			return{
				parts : {},
				details : null,
				details_parts : '',
			}
		},
		mounted() {
			//Keybindings
			document.addEventListener('keydown',function(e) {
				switch(e.which) {
					case 37: // left
						if(this.details!= null){
							var index = this.flat_vairus_list.findIndex(function(v){ return v.id == this.details.id; }.bind(this));
							index = Math.max(0, index-1);
							
							this.details = this.flat_vairus_list[index];
							e.preventDefault();
						}
					break;
					case 39: // right
						if(this.details!= null){
							var index = this.flat_vairus_list.findIndex(function(v){ return v.id == this.details.id; }.bind(this));
							index = Math.min(this.flat_vairus_list.length-1, index+1);
							
							this.details = this.flat_vairus_list[index];
							e.preventDefault();
						}
					break;
					case 27: // esc
						if(this.details != null){
							this.details = null;
						}else{
							this.$emit('close');
						}
						e.preventDefault();
					break;
				}
			}.bind(this));
			
		},
		methods: {
			imageStyle(id, part, unlocked){
				let image_url = this.getVairusImage(id, part);
				
				if(unlocked){
					return {
						'background-image' : image_url,
					};
				}else{
					return {
						'background-color' : 'black',
						'mask' : image_url+' 0 0/100% 100%',
						'-webkit-mask' : image_url+' 0 0/100% 100%'
					};
				}
			},
			selectPart(index, part){
				if(this.parts[index] != part)
					this.$set(this.parts, index, part);
				else
					this.$set(this.parts, index, '');
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			CloseIcon,
		}
	}
</script>


<style lang="scss" scoped>

	.codex{
		border-radius: 10px;
			
		> .header{
			padding: 1rem 1.785714285% 2rem;
			
			.title, 
			.actions{
				width: 200px;
				flex-shrink: 0;
			}
			
			.score-bar{
				position: relative;
				width: 100%;
				padding: 0 20px;
				margin-top: 5px;
				
				
				.bar{
					position: relative;
					height: 6px;
					background-color: #4A3349;
					border: 1px solid black;
					
					.dot{
						position: absolute;
						top: 50%;
						transform: translate(-5px, -50%);
						width: 11px;
						height: 11px;
						border-radius: 50%;
						border-width: 3px;
						border-style: solid;
						
						&:before{
							box-shadow: none;
						}
					}
					
					.base{
						height: 100%;
						transition: width 0.1s;
						width: 0;
						transition: width 0.3s linear;
					}
				}
			}
		}
	
		.container{
			position: relative;
			overflow: hidden;
			padding-top: 217.3077%;
			
			svg{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
			}
			
			.grid{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				overflow-y: auto;
				
				.entry{
					position: relative;
					display: flex;
					flex-direction: column;
					justify-content: space-between;
					float: left;
					width: 17.85714285%;
					height: 11.5044241%;
					margin-left: 1.785714285%;
					margin-top: 1.95%;
					border: 3px solid #628092;
					border-radius: 10px;
					background: linear-gradient(rgba(14,45,63,0.5), rgba(17,7,15,0.5));
					
					&.margin-right{
						margin-right: 1.785714285%;
					}
					&.margin-bottom{
						margin-bottom: 0.8849557%;
					}
					
					&.epic{
						&.mountain{
							background: linear-gradient(rgba(182,115,65,0.5), rgba(17,7,15,0.5));
						}
						&.sky{
							background: linear-gradient(rgba(242,242,242,0.5), rgba(17,7,15,0.5));
						}
						&.desert{
							background: linear-gradient(rgba(255,206,74,0.5), rgba(17,7,15,0.5));
						}
						&.ocean{
							background: linear-gradient(rgba(56,160,210,0.5), rgba(17,7,15,0.5));
						}
						&.swamp{
							background: linear-gradient(rgba(229,227,35,0.5), rgba(17,7,15,0.5));
						}
						&.city{
							background: linear-gradient(rgba(191,210,210,0.5), rgba(17,7,15,0.5));
						}
						&.glacier{
							background: linear-gradient(rgba(191,210,210,0.5), rgba(17,7,15,0.5));
						}
						&.forest{
							background: linear-gradient(rgba(123,164,29,0.5), rgba(17,7,15,0.5));
						}
					}
					
					.name{
						text-transform: lowercase;
						&:first-letter {
							text-transform: uppercase;
						}
					}
					
					.card-header{
						padding: 10px;
						padding-top: 15px;
						cursor: pointer;
					}
					
					.content{
						padding: 0 20px;
						padding-top: 0;
						cursor: pointer;
						
						.wrapper{
							position: relative;
							padding-top: 100%;
							
							.image{
								position: absolute;
								top: 0;
								bottom: 0;
								left: 0;
								right: 0;
								background-color: white;
								border-radius: 50%;
								border-width: 5px ;
								border-style: solid;
								overflow: hidden;
								
								.part{
									position: absolute;
									top: 0;
									left: 0;
									right: 0;
									bottom: 0;
									background-size: cover;
									background-position: center;
									display: none;
									
									&.visible{
										display: block;
									}
								}
							}
						}
					}
					
					.card-footer{
						padding: 10px;
						padding-bottom: 20px;
						justify-content: center;
						
						.attribute{
							width: 15px;
							height: 15px;
							margin: 8px 10px 0;
							transform: rotate(-45deg);
							cursor: pointer;
							
							&.locked{
								background-color: rgba(255,255,255,0.2) !important;
							}
							&.selected{
								border: 2px solid white;
							}
						}
					}
					
					&.glitch{
						.image .part{
							filter: invert(1);
						}
					}
				}
			}
		}
		
		.details{
			position: fixed;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			z-index: 5;
			
			.backdrop{
				position: absolute;
				top: 0;
				left: 0;
				bottom: 0;
				right: 0;
				background-color: rgba(0, 0, 0, 0.7);
			}
			
			.content{
			    position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
				border-radius: 10px;
				width: 600px;
				max-width: 95vw;
				max-height: 95vh;
				overflow-y: auto;
				
				.title{
					position: relative;
					
					.close-icon{
						position: absolute;
						right: 0;
						top: 0;
					}
				}
				
				.midsection{
					position: relative;
					overflow: hidden;
					
					svg{
						position: absolute;
						left: -1px;
						top: -1px;
						height: 100%;
						width: 100%;
					}
				}
				
				.image-wrapper{
					position: relative;
					transition: all 0.3s ease 0s;
					margin-top: 0;
					margin-bottom: 0;
			
					.image{
						position: relative;
						height: 200px;
						width: 200px;
						margin: 20px auto;
						z-index: 0;
						background-color: white;
						border-radius: 50%;
						border-width: 5px ;
						border-style: solid;
						overflow: hidden;
						
						.part{
							position: absolute;
							top: 0;
							left: 0;
							right: 0;
							bottom: 0;
							background-size: cover;
							background-position: center;
							display: none;
							
							&.visible{
								display: block;
							}
						}
					}
				}
				
				.description{
					margin: 20px 0;
				}
			}
		}
	}
	
	@media screen and (max-width: 950px) {
		.codex .entry{
			.name{
				font-size: 2rem;
			}
		}
	}
	
	@media screen and (max-width: 800px) {
		.codex .entry{
			.card-header{
				padding-top: 10px !important;
				padding-bottom: 5px !important;
			}
			.card-footer{
				padding-top: 5px !important;
				padding-bottom: 10px !important;
			}
		}
		.codex > .header .title, 
		.codex > .header .actions{
			width: 100px !important;
		}
	}
	
	@media screen and (max-width: 660px) {
		.codex .entry{
			width: 22.8% !important;
			height: 15% !important;
			
			&.margin-right{
				margin-right: 0 !important;
			}
		}
	}
	
	@media screen and (max-width: 480px) {
		.codex .entry{
			width: 31% !important;
			height: 20% !important;
		}
		.codex > .header .title{
			width: 60px !important;
		}
		.codex > .header .actions{
			width: 40px !important;
		}
	}
	
	@media screen and (max-width: 380px) {
		.codex .entry{
			width: 47.5% !important;
			height: 31% !important;
		}
	}
	
	
	@-webkit-keyframes shine {
		0%{background-position:10% 0%}
		50%{background-position:91% 100%}
		100%{background-position:10% 0%}
	}
	@keyframes shine { 
		0%{background-position:10% 0%}
		50%{background-position:91% 100%}
		100%{background-position:10% 0%}
	}
</style>
